#include "aubo_sdk/rpc.h"

using namespace arcs::common_interface;
using namespace arcs::aubo_sdk;

void exampleStartup(RpcClientPtr cli)
{
    auto robot_name = cli->getRobotNames().front();

    if (RobotModeType::Running != cli->getRobotInterface(robot_name)
                                      ->getRobotState()
                                      ->getRobotModeType()) {
        // poweron
        cli->getRobotInterface(robot_name)->getRobotManage()->poweron();
        while (1) {
            if (RobotModeType::Idle == cli->getRobotInterface(robot_name)
                                           ->getRobotState()
                                           ->getRobotModeType()) {
                printf("上电成功:%d\n", cli->getRobotInterface(robot_name)
                                            ->getRobotState()
                                            ->getRobotModeType());
                break;
            }
            printf("正在上电:%d\n", cli->getRobotInterface(robot_name)
                                        ->getRobotState()
                                        ->getRobotModeType());
            std::this_thread::sleep_for(std::chrono::seconds(1));
        }

        // break release
        cli->getRobotInterface(robot_name)->getRobotManage()->startup();
        while (1) {
            if (RobotModeType::Running == cli->getRobotInterface(robot_name)
                                              ->getRobotState()
                                              ->getRobotModeType()) {
                printf("松刹车成功:%d\n", cli->getRobotInterface(robot_name)
                                              ->getRobotState()
                                              ->getRobotModeType());
                break;
            }
            printf("正在松刹车:%d\n", cli->getRobotInterface(robot_name)
                                          ->getRobotState()
                                          ->getRobotModeType());
            std::this_thread::sleep_for(std::chrono::seconds(1));
        }
    }
}

void examplePoweroff(RpcClientPtr cli)
{
    auto robot_name = cli->getRobotNames().front();
    // 断电
    cli->getRobotInterface(robot_name)->getRobotManage()->poweroff();
}

#define ip_local "127.0.0.1"

int main(int argc, char **argv)
{
    auto rpc_cli = std::make_shared<RpcClient>();
    rpc_cli->connect(ip_local, 30004);
    rpc_cli->login("aubo", "123456");

    exampleStartup(rpc_cli);
    examplePoweroff(rpc_cli);
}
